--Monitor Module

--[[This module could be clearly cleaned up! But... something strange happens.
EffectAdded sends the index of the new effect. effects:Get(args.Index):GetName() will get it's name
EffectRemoved sends then actual effect. args.Effect:GetName() will get it's name]]

--Monitors for certain buffs/debuffs etc and shows a bar when they hit, or not.

import "Turbine.Gameplay.Attributes"
import "Turbine.Gameplay"

function initialisemonitor()
	--Set up a watch for monitors

	monitorwatcher()
	monitorupdate()

end

function monitorwatcher()
	--Watch for monitor change
	handle1 = AddCallback(effects, "EffectAdded", 		function(sender, args ) monitorupdate() end)
	handle2 = AddCallback(effects, "EffectRemoved", 	function(sender, args ) monitorupdate() end)
	handle3 = AddCallback(effects, "EffectsCleared", 	function(sender, args ) monitorupdate() end)
end

function monitorupdate()
	
		local n=effects:GetCount()
		local list={}
		
		for i=1,n do
			local cat=effects:Get(i):GetName()
			list[i]=cat
		end
	
		for i=1,#Bar do
			if Bar[i].Data.monitor~=nil then
				local test=search(list,Bar[i].Data.monitor)
				if Bar[i].Data.monitorNOT then test=not(test) end	--If the test is to NOT have a certain buff list then...
				Bar[i].InMonitor=test
				Bar[i]:Show()
			end
		end
end
--[[
--Not working as it suffers from the "Dual proc" bug. Safer to scan all buffs every time.
	handle1 = AddCallback(effects, "EffectAdded", 		function(sender, args ) SpecificEffect (effects:Get(args.Index):GetName(),true) end) 
	handle2 = AddCallback(effects, "EffectRemoved", 	function(sender, args ) SpecificEffect (args.Effect:GetName(),false) end)
function SpecificEffect(k,f)
	if f then Turbine.Shell.WriteLine(k.." added") else Turbine.Shell.WriteLine(k.." removed") end
	for i=1,#Bar do
		if Bar[i].Data.monitor~=nil then
			if search({k},Bar[i].Data.monitor) then			
				if Bar[i].Data.monitorNOT then Bar[i].InMonitor=not Bar[i].flag else Bar[i].InMonitor=Bar[i].flag end
				Bar[i]:Show()
			end
		end
	end
end]]

function search (list1,list2)
	--This functions seaches every element of list1 and sees if there is a matching element in list2
	for i=1,#list1 do
		for j=1,#list2 do
			if list1[i]==list2[j] then return true end
		end
	end
	return false
end

table.insert(Context,
function (self,contextMenu,contextMenuItems)
--Add the "monitor Bar" option to every Bar.
	local monitorBar = Turbine.UI.MenuItem( "Monitor for buff:")
		monitorBar.Click = function( sender, args )
			import "JackdawPlugins.Bevy2.MonitorOptions"
			ShowMonitorOption(self)
		end	
		
	contextMenuItems:Add( monitorBar )
end)

CollectCommand = Turbine.ShellCommand()
function CollectCommand:Execute(command, i)
	--/cb runs the commands for this module. /cb on its own changes the collect flag. /cb print prints all the current buffs that have been recorded FOR THIS CLASS.
	if i=="print" then 
		PrintBuffList()
	else
		collect=not(collect)
		BuffCollector()
	end
end
Turbine.Shell.AddCommand('CB', CollectCommand)

function BufflistLoad()
--Due to the way Turbine code works this function is called *Twice* and, thus, needs a merge function. This way buffs that happen to the player early on are not lost.

	--Default to collecting
	if collect==nil then collect=true end
	
	BuffCollector()
	--Time delay bug needs this to happen - annoying, but it works.
	LoadWait:SetWantsUpdates(true)
end

LoadWait=Turbine.UI.Control()

function LoadWait:Update()
	
	--1. Return if the load file is empty
	--		Otherwise, wait until it *isn't* empty before performing the merge.
	--		Yes, this will run indefinately if the plugin runs for the first time... shhh... don't tell anyone...
	if loadbufflist==nil then 
		return 
	else 
		--Turbine.Shell.WriteLine("Not nil - merging")
		LoadWait:SetWantsUpdates(false) 
	end
	
	MergeList()
end

function MergeList()

	if bufflist==nil then bufflist={} end
	
	--Begin to parse through the load file.
	if loadbufflist~=nil then
		for i in pairs(loadbufflist) do
			--3. Merge if a class is missing altogether
			if bufflist[i]==nil then 
				bufflist[i]=loadbufflist[i] 
			else
				--4. Merge if a category is missing
				for j in pairs(loadbufflist[i]) do
					if bufflist[i][j]==nil then 
						bufflist[i][j]=loadbufflist[i][j]
					else
						--5. Merge if an individual buff is missing
						for k in pairs(loadbufflist[i][j]) do
							local Name=loadbufflist[i][j][k]
							if not(search (bufflist[i][j],{Name})) then 
								table.insert(bufflist[i][j],Name) 
							end
						end
					end
				end
			end
		end
	end
end

function BuffCollector()
	if collect then
		if handle4==nil then
			ColorWrite(0.5,0.5,0.5,"Buff Monitor module; Currently collecting buffs for options. Type /cb to stop buff collection. This does not disable the plugin")
			handle4 = AddCallback(effects, "EffectAdded", function(sender, args ) 
				local thiseffect=effects:Get(args.Index)	--Get the effect
				--Now, collect it.
				CollectBuff(thiseffect)
			end)
		end
	else
		if not printed then
			ColorWrite(0.5,0.5,0.5,"Buff Monitor module; Not collecting buffs for options. Type /cb to start buff collection. This does not disable the plugin")
			printed=true
			if handle4~=nil then RemoveCallback(effects, "EffectAdded", handle4) handle4=nil end
		end
	end
end

function PrintBuffList ()
local n=effects:GetCount()

		for j=1,n do
			local thiseffect=effects:Get(j)
			CollectBuff(thiseffect)
		end
	table.sort(bufflist[PlayerClass])
	for j in pairs(bufflist[PlayerClass]) do
		table.sort(bufflist[PlayerClass][j])
	end
	ColorWrite(0.5,1,0.5,"Cuurent buffs that have been colllected;")
	for j in pairs(bufflist[PlayerClass]) do
		table.sort(bufflist[PlayerClass][j])
		for i=1,#bufflist[PlayerClass][j] do
			Turbine.Shell.WriteLine("          "..bufflist[PlayerClass][j][i])
		end
	end
end


function CollectBuff(thiseffect)
	--Collects thiseffect into the list!
	local Name=thiseffect:GetName()
	local Category=thiseffect:GetCategory()
	
	--This fix is just in case the various data has not loaded.
	if bufflist==nil then bufflist={} end
	if bufflist[PlayerClass]==nil then bufflist[PlayerClass]={} end
	if bufflist[PlayerClass][Category]==nil then bufflist[PlayerClass][Category]={} end
	
	if not(search (bufflist[PlayerClass][Category],{Name})) then 
		table.insert(bufflist[PlayerClass][Category],Name) 
		ColorWrite(0.5,0.5,0.5,"Collected "..classes[PlayerClass].."; "..Name.." for the buff monitor ") 
	end
end

--Perform a delayed load.
loadbufflist=JackdawPlugins.Patch.Load( Turbine.DataScope.Account, "BevyOBars2Bufflist",BufflistLoad )
initialisemonitor()

table.insert(Opt.Module,
	function()

	Opt.MonitorBox=CollapseBox("Monitor Options","f",1,true)
	
	Opt.ListBox:AddItem(Opt.MonitorBox)
	
	Opt.BMonitor=optionlabel(320,"",false)
	Opt.BMonitor:SetHeight(32)
	
	Opt.monitor=Dummy()	--Dummy
	
	Opt.MonitorBox.Content:AddItem(Opt.BMonitor)
	
	table.insert(Opt.source,"monitor")
	Opt.table.monitor=true
	
	Opt.MonitorOpt=Turbine.UI.Lotro.Button()
	Opt.MonitorOpt:SetText("Show Monitor Options")
	Opt.MonitorOpt.MouseDown=function() 
		import "JackdawPlugins.Bevy2.MonitorOptions"
		ShowMonitorOption(Bar[Opt.OneBarid])
		Opt.Window:Close()
	end
	Opt.MonitorBox.Content:AddItem(Opt.MonitorOpt)

	end)
	
table.insert(Opt.Updaters, 
	function()
		if Opt.BMonitor~=nil then
			local txt=""
			if not Opt.OneBar then 
				txt="Cannot show this option for more than one bar"
				Opt.MonitorOpt:SetEnabled(false)
			else
				txt="Currently Monitoring; "
				if #Opt.tab.monitor==0 then txt=txt.."Nothing" end
				for l=1,#Opt.tab.monitor do
					txt=txt..Opt.tab.monitor[l]
					if l<#Opt.tab.monitor then txt=txt..", " end
				end
				Opt.MonitorOpt:SetEnabled(true)
			end
			Opt.BMonitor:SetText(txt)
		end
	end)
	